<template>
  <div class="hsInputBox" :id='elId'>
     <div class="inputCurr">
        <el-divider id="divider"  :direction='configData.direction' :content-position='configData.contentPosition'>{{configData.title}}</el-divider>
     </div>
    <jsoneditor v-model='jsoneditorVisible'
                :elInfo='elInfo'
                :layout='layout'
                :jsoneditorCloseAfter='jsoneditorCloseAfter'
                :jsoneditorOpenAfter='jsoneditorOpenAfter'
                >
    </jsoneditor>
  </div>
</template>
<script>
import ucComponent from '../ucClass/uc_component'
import uuidv1 from 'uuid/v1'
import jsoneditor from '../common/jsoneditor'
export default {
  mixins: [ucComponent],
  components: {
    jsoneditor
  },
  name: 'hsDivider',
  props: {
    allSourceData: {
      type: Object,
      default() {
        return {}
      }
    },
    elInfo: {
      type: Object,
      default() {
        return {}
      }
    },
    value: '',
    layout: {},
    jsoneditorCloseAfter: {
      type: Function
    },
    jsoneditorOpenAfter: {
      type: Function
    }
  },
  watch: {
    allSourceData: {
      handler: function(newVal, oldVal) {
        const { config } = newVal
        this.initConfig(config)
      },
      deep: true
    },
    value(val) {
      this.value_inner = val
    },
    value_inner(val) {
      this.$emit('input', val)
    }
  },
  data() {
    return {
      elId: '',
      value_inner: '',
      jsoneditorVisible: false,
      configData: {
        direction: 'horizontal',
        contentPosition: 'left',
        title: '',
        lineStyle: {
          backgroundColor: 'red'
        }
      }
    }
  },
  created() {
    this.elId = uuidv1() // 获取随机id
  },
  mounted() {
    this.$nextTick(() => {
      const { config } = this.allSourceData
      this.initConfig(config)
    })
  },
  methods: {
    initConfig(config = {}) {
      if (!config) return
      this.configData = Object.assign(this.configData, config)
      for (const p in config.lineStyle) {
        document.getElementById('divider').style[p] = config.lineStyle[p]
      }
    },
    submitInput(val) {
      const parm = {}
      parm[this.elInfo.prop] = this.value_inner
      this.$emit('enterInput', parm)
    }
  }
}
</script>
<style scoped>
.hsInputBox{
  padding: 1px;
  width:100%;
  height:100%;
  display: flex;
}
.inputTitle{
  flex:1;
  display: flex;
  justify-content: center;
  align-items: center;
}
.inputCurr{
  flex: 3;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
